<template>
  <section admin>
    <h1>L1CE</h1>
    <section>
      <md-card class="md-card-example" :color="versionCardColor">
        <md-card-area md-inset>
          <md-card-header>
            <p class="md-title">Version</p>
          </md-card-header>

          <md-card-content>
            <p bigger>{{versionstring}}</p>
            <div tags>
              <Tag color="green" v-if="buildstats.build.CI">GitLab CI build</Tag>
              <Tag color="red" v-else>not built from GitLab CI</Tag>
              <Tag color="yellow" v-if="buildstats.git.trailing_commits">not based on a git tag</Tag>
              <Tag color="red" v-if="buildstats.git.uncommitted_files">based on uncommited code</Tag>
            </div>
          </md-card-content>
        </md-card-area>

        <md-card-content>
          <table>
            <tr><td>git commit:</td><td>{{buildstats.git.hash}} ({{buildstats.git.branch}})</td></tr>
            <tr><td>build host:</td><td>{{buildstats.build.host}}</td></tr>
            <tr><td>build date:<br>&nbsp;</td><td>
              <span>{{buildstats.build.timestamp}}</span><br>
              <span>{{relativeTime(buildstats.build.timestamp, counter)}}</span></td></tr>
          </table>
        </md-card-content>
        <md-card-actions>
          <md-button :href="gitlabURL" target="new">View in GitLab</md-button>
        </md-card-actions>
      </md-card>

      <section>
        <md-card>
          <md-card-header>
            <p class="md-title">Uptime</p>
            <p class="md-subhead">Service restarts can be performed in L1Page</p>
          </md-card-header>
          <md-card-content>
            <p bigger>{{relativeTime(serverStarttime, counter, true)}}</p>
            <p>{{serverStarttime}}</p>
          </md-card-content>
          <md-card-actions>
            <md-button href="http://l1page.cms" target="new">go to L1Page</md-button>
          </md-card-actions>
        </md-card>

        <!-- <md-card>
          <md-card-header>
            <p class="md-title">Metrics</p>
            <p class="md-subhead">Full metrics data can be viewed in Prometheus</p>
          </md-card-header>
          <md-card-content>
            <p bigger>last scrape: TODO for v1</p>
          </md-card-content>
          <md-card-actions>
            <md-button href="http://l1page.cms" target="new">View L1CE Metrics</md-button>
          </md-card-actions>
        </md-card> -->
      </section>

      <md-card flex limit-height>
        <md-card-header>
          <p class="md-title">Logs</p>
          <p class="md-subhead">Full logs data can be viewed in ?</p>
        </md-card-header>
        <md-card-content>
          <table>
            <tr>
              <th>time</th>
              <th>level</th>
              <th>message</th>
              <th>location</th>
            </tr>
            <tr v-for="(log, i) in serverLogs" :key="i">
              <td>{{log.time}}</td>
              <td>{{getLogLevel(log.level)}}</td>
              <td>{{log.msg}}</td>
              <td>{{log.src.file}}:{{log.src.line}}</td>
            </tr>
          </table>
        </md-card-content>
        <md-card-actions>
          <md-button href="http://l1page.cms" target="new">View L1CE Logs</md-button>
        </md-card-actions>
      </md-card>
    </section>
<!--     
    logs
    metrics -->

    <h1>Connected Users</h1>
<!--     
    - token data
    - token lifecycle
    - changes -->
    <section>
      <md-card color="blue" v-if="store.state.auth.userData">
        <md-card-header class="md-title">{{store.state.auth.userData.cern.fullname}}</md-card-header>
        <md-card-content>
          <p>{{store.get.database('mychanges').length}} pending changes</p>
          <p>{{getRemainingSeconds(counter)}}s token lifetime left</p>
          <Tag color="gray" v-for="role in store.state.auth.userData.l1ce.roles" :key="role">{{role}}</Tag>
        </md-card-content>
        <md-card-actions>
          <md-button @click="store.dispatch.auth('renew')">Renew token</md-button>
          <md-button @click="store.dispatch.auth('logout')">Delete token</md-button>
        </md-card-actions>
      </md-card>
      <md-card v-for="user in otherUsers" :key="user.name">
        <md-card-header class="md-title">{{user.name}}</md-card-header>
        <md-card-content>
          <p>{{user.changes.length}} pending changes</p>
        </md-card-content>
      </md-card>
    </section>

    <h1>Database</h1>
<!--     
    - open connections
    - config -->
    <section>
      <md-card>
        <md-card-header class="md-title">{{store.state.auth.userData.cern.fullname}}</md-card-header>
        <md-card-content>
          <p>{{Object.keys(store.state.database.cache).length}} browser cache entries</p>
          <p>available databases: {{availableDatabases}}</p>
        </md-card-content>

      </md-card>
    </section>
  </section>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import { MdCard } from 'vue-material/dist/components';
import buildstats from '../lib/buildstats';
import moment from 'moment';
import { clearTimeout } from 'timers';
import Tag from './Tag.vue';
import axios from '../lib/axios';
import goStyle from '../lib/to';
import { store } from '../store';

Vue.use(MdCard);
@Component({
  components: {
    Tag,
  },
})
export default class extends Vue {

  // tslint:disable-next-line:no-empty
  private counterTimer: NodeJS.Timer = setTimeout(() => {}, 0);
  private counter = 0;

  private serverLogs = [];
  private serverStarttime = '';

  private availableDatabases: string[] = [];

  get buildstats() {
    return buildstats;
  }

  get versionstring(): string {
    const g = buildstats.git;
    let tag = g.latest_tag;
    const meta: string[] = [];
    if (g.trailing_commits) {
      meta.push(g.trailing_commits + '');
      meta.push(g.hash);
    }
    if (g.uncommitted_files) {
      meta.push('dirty');
    }
    if (meta.length) {
      tag += '+' + meta.join('.');
    }
    return tag;
  }

  get gitlabURL(): string {
    const base = 'https://gitlab.cern.ch/cms-cactus/web/L1CE';
    if (buildstats.git.trailing_commits) {
      return `${base}/commit/${buildstats.git.hash}`;
    } else {
      return `${base}/tags/${buildstats.git.latest_tag}`;
    }
  }

  get versionCardColor() {
    if (buildstats.git.uncommitted_files || !buildstats.build.CI) {
      return 'red';
    } else if (buildstats.git.trailing_commits) {
      return 'yellow';
    } else {
      return 'white';
    }
  }

  get store() {
    return store;
  }

  get otherUsers() {
    const s = store.state.database.changes;
    const userData = store.state.auth.userData;
    if (!userData) {
      return [];
    }
    const username = userData.cern.fullname;
    return Object.keys(s).filter(n => n !== '_links' && n !== username).map(name => ({name, changes: s[name]}));
  }

  public created() {
    this.scheduleCounter();
    this.fetchStartTime(); // new server start time = invalid credentials = reload
    this.fetchDBCapabilities();
  }
  public beforeDestroy() {
    clearTimeout(this.counterTimer);
  }
  private scheduleCounter() {
    if (this.counter === 0) {
      this.fetchLogs();
    }
    this.counterTimer = setTimeout(() => {
      this.counter = ++this.counter % 10;
      this.scheduleCounter();
    }, 1000);
  }

  private relativeTime(d: string, i, omitAgo = false): string {
    return moment(d).fromNow(omitAgo);
  }

  private async fetchLogs() {
    const [response, err] = await goStyle(axios({
      url: `/api/v0/logs`,
      errorReporting: 'nonblocking',
    }));
    if (response) {
      this.serverLogs = response.data.split('\n').filter(l => l).reverse().map(l => {
        try {
          return JSON.parse(l);
        } catch (error) {
          return {level: 0, msg: l, src: {file: '/', line: '/'}};
        }
      });
    }
  }

  private async fetchDBCapabilities() {
    const {data} = await store.dispatch.database('cachedAxios', {url: '/api/v0/db/capabilities'});
    this.availableDatabases = Object.keys(data).filter(d => d !== '_links');
  }

  private async fetchStartTime() {
    const [response, err] = await goStyle(axios({
      url: `/api/v0/starttime`,
      errorReporting: 'nonblocking',
    }));
    if (response) {
      this.serverStarttime = response.data;
    }
  }

  private getLogLevel(level: number) {
    switch (level) {
      case 0:
        return 'N/A';
      case 10:
        return 'trace';
      case 20:
        return 'debug';
      case 30:
        return 'info';
      case 40:
        return 'warn';
      case 50:
        return 'error';
      case 51:
        return 'success';
      case 60:
        return 'fatal';
      default:
        return level;
    }
  }

  private getRemainingSeconds() {
    const a = store.state.auth;
    if (!a.userData) {
      return 0;
    }
    const lastrenew = moment(a.lastRenewDate);
    const tokenSeconds = a.userData.exp - a.userData.iat;
    lastrenew.add(tokenSeconds, 'seconds');
    return lastrenew.diff(moment(), 'seconds');
  }
}
</script>

<style scoped lang="scss">
$cardColors: 'red' md-get-palette-color(red, A200) md-get-palette-color(red, A400) white,
             'yellow' md-get-palette-color(amber, A200) md-get-palette-color(amber, A400) black,
             'green' md-get-palette-color(green, 500) md-get-palette-color(green, 600) white,
             'blue' md-get-palette-color(blue, 500) md-get-palette-color(blue, 600) white;

[admin] {
  h1 {
    font-size: 1.4em;
    margin-left: 16px;
  }

  & > section {
    display: flex;
    flex-direction: row;
    flex-wrap: wrap;
    align-items: flex-start;
    align-items: stretch;

    & > section {
      display: flex;
      flex-direction: column;
      flex-wrap: wrap;
      align-items: flex-start;
      align-items: stretch;

      .md-card:not(:last-child) {
        margin-bottom: 16px;
      }
    }
  }

  .md-card {
    display: flex;
    flex-direction: column;

    .md-card-content {
      flex: 1;
    }

    @each $tuple in $cardColors {
      &[color='#{nth($tuple, 1)}'] {
        // background: #{nth($tuple, 2)};
        background: linear-gradient(113deg, #{nth($tuple, 2)} 0, #{nth($tuple, 3)} 50%);
        color: #{nth($tuple, 4)};

        .md-button:not(.md-primary):not(.md-accent) {
          color: #{nth($tuple, 4)};
        }
      }
    }

    [tags] {
      display: flex;
      flex-direction: column;
      align-items: flex-start;
      justify-content: flex-start;
      flex-wrap: wrap;
    }

    [bigger] {
      margin: 0;
      margin-bottom: 1em;
      font-size: 1.2em;
    }

    &[limit-height] {
      .md-card-content {
        overflow: auto;
        max-height: 400px;
      }
    }
  }
}
</style>
